#property indicator_separate_window //  
#property indicator_buffers 6
#property indicator_color1 Silver
#property indicator_color6 Blue
#property indicator_maximum 1
#property indicator_minimum 0

//  
//--
extern int Indicator=0; // 0 - ; 1 - ; 2 - . 
extern int IndPeriod=5;
 int Shift=0;
 bool MAtypeI=1;
extern int Norm=12;
 bool NormMethod=0; // 0 -    , 1 - 
extern int Sensitivity=8;
extern int Smooth=9;
 bool MAtypeS=1;

extern int History=0;
 
//  
double Ind[], //  
      NORM[], //  
      SM[], // 
      Input[], //     (  )
      MA[], //   
      NP[]; //    -     -  

double NormLimit, //    
      sens, //    /
      sensLimit, //  
      IndPeriodK, // . EMA  
      SmoothK; // . EMA  
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexBuffer(0,SM);
   SetIndexStyle(0,DRAW_LINE);
   SetIndexLabel(0,"Smooth");

   SetIndexBuffer(1,Ind);
   SetIndexStyle(1,DRAW_NONE);
   SetIndexLabel(1,"Indicator");

   SetIndexBuffer(2,NORM);
   SetIndexLabel(2,"Normed");

   SetIndexBuffer(3,MA);
   SetIndexStyle(3,DRAW_NONE);
   SetIndexLabel(3,NULL);

   SetIndexBuffer(4,Input);
   SetIndexStyle(4,DRAW_NONE);
   SetIndexLabel(4,NULL);

   SetIndexBuffer(5,NP);
//   SetIndexLabel(5,NULL);
   if(Indicator==-1 && Sensitivity>0) //    
     {
      SetIndexStyle(5,DRAW_HISTOGRAM); 
      Indicator=-Indicator;
     }
   else SetIndexStyle(5,DRAW_NONE);

   if(Indicator==1 && Sensitivity>0) SetIndexLabel(5,"NormPeriod");
   else SetIndexLabel(5,NULL);

//----
   string _shift,ShortName;
   double punkt;
   
   switch(Indicator)
     {
      case 0:
         SetIndexStyle(2,DRAW_LINE,0,1,RoyalBlue);
         ShortName="VolumeMA";
         punkt=1;
         break;
      case 1:
         SetIndexStyle(2,DRAW_LINE,0,1,LightSeaGreen);
         ShortName="CloseMA";
         NormMethod=1; //     
         NormLimit=Norm*10; //    
         punkt=Point;
         break;
      case 2:
         SetIndexStyle(2,DRAW_LINE,0,1,MediumSeaGreen);
         ShortName="CloseStDev";
         punkt=Point;
     }
   
   sensLimit=punkt/1000; //  
   sens=MathMax(Sensitivity*punkt,sensLimit); //    
   
   if(IndPeriod<0) {MAtypeI=0; IndPeriod=-IndPeriod;}
   else IndPeriodK=2.0/(IndPeriod+1);
   
   if(Smooth<0) {MAtypeS=0; Smooth=-Smooth;}
   else SmoothK=2.0/(Smooth+1);

   if(Shift>0) _shift="+"+Shift;
   ShortName=ShortName+"("+IndPeriod+")"+_shift+" ["+Norm+"/"+Sensitivity+" "+Smooth+"]";

   IndicatorShortName(ShortName); //     
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int ic=IndicatorCounted();
   if(Bars-ic-1>1) {ic=reinit();}
   int limit=Bars-ic-1; //BarsPrev=Bars; // - 
   if(History!=0 && limit>History) limit=History-1; // -   

   for(int i=limit; i>=0; i--) //      
     {
      //  
      if(Indicator>0) Input[i]=Close[i]; // 
      else Input[i]=Volume[i]; // 
     
     // MA
     double ma=0;
      if(MAtypeI)
        {
         MA[i]=IndPeriodK*Input[i]+(1-IndPeriodK)*MA[i+1];
         ma=MA[i+Shift];
        }
      else
        {
         for(int n=0; n<IndPeriod; n++) ma+=Input[i+Shift+n];
         ma/=IndPeriod;
        }
      
      // .
      if(Indicator<2) Ind[i]=ma; //   ()
      else //  
        {
         double std=0;
         for(n=0; n<IndPeriod; n++) 
           {
            double delta=Input[i+Shift+n]-ma;
            std+=delta*delta;  //  IndPeriod(Price)
           }
         Ind[i]=MathSqrt(std/IndPeriod);
        }

      // 
      double max,min;
      if(NormMethod) //    
        {
         max=0; min=0;
         for(n=Norm; max-min<sens && n<=NormLimit; n++)
           {
            max=Ind[ArrayMaximum(Ind,n,i)];
            min=Ind[ArrayMinimum(Ind,n,i)];
           }
         NORM[i]=(Ind[i]-min)/MathMax((max-min),sensLimit);
         NP[i]=n-1; //   
        }
      else //    
         if(Indicator>0) //  
           {
            max=Ind[ArrayMaximum(Ind,Norm,i)];
            min=Ind[ArrayMinimum(Ind,Norm,i)];
            NORM[i]=(Ind[i]-min)/MathMax((max-min),sens);
           }
         else //  
           {
            max=Ind[ArrayMaximum(Ind,Norm,i+1)];
            min=Ind[ArrayMinimum(Ind,Norm,i+1)];
            double x;
            if(Ind[i]<min) x=min; else x=Ind[i];
            if(Ind[i]>max) x=max; else x=Ind[i];
            NORM[i]=(x-min)/MathMax((max-min),sens);
           }

      //  .
      if(MAtypeS)
         SM[i]=SmoothK*NORM[i]+(1-SmoothK)*SM[i+1];
      else
        {         
         double sm=0;
         for(n=0; n<Smooth; n++) sm+=NORM[i+n];
         SM[i]=sm/Smooth;
        }
     }
//----
   return(0);
  }

//----------------------------------------------------  
// -  
int reinit()
  {
   ArrayInitialize(Ind,0.0);
   ArrayInitialize(NORM,0.0);
   ArrayInitialize(SM,0.0);
   ArrayInitialize(MA,0.0);
   return(0);
  }

int deinit()
  {
   return(0);
  }

//+------------------------------------------------------------------+

